class WorkcostsbyRole(PWReportPage):
	def init(self):
		super(WorkcostsbyRole, self).init()
		self.project				= None
		self.withObjective 			= True
		self.withTimes 		 		= True
		self.iterItem				= None
		self.iterIndex				= 0
		self.iterTitle			    = None
		self.iterTitleIndex	        = 0
		self.iterTask			    = None
		self.iterTaskIndex	        = 0
		self.milestonesSortDescriptors			= [NSSortDescriptor.alloc().initWithKey_ascending_("expectedEndDate", True)]
		self.upcomingActivitiesSortDescriptors	= [NSSortDescriptor.alloc().initWithKey_ascending_("expectedStartDate", True)]
		self.overdueActivitiesSortDescriptors	= [NSSortDescriptor.alloc().initWithKey_ascending_("expectedStartDate", True)]
		self.deadlineActivitiesSortDescriptors	= [NSSortDescriptor.alloc().initWithKey_ascending_("expectedStartDate", True)]
		self.infoElementsSortDescriptors		= [NSSortDescriptor.alloc().initWithKey_ascending_("informationDate", True)]
		self.issuesSortDescriptors				= [NSSortDescriptor.alloc().initWithKey_ascending_("fixUntilDate", True)]
		self.risksSortDescriptors				= [NSSortDescriptor.alloc().initWithKey_ascending_("recordingDate", True)]
		self.resourcesSortDescriptors			= [NSSortDescriptor.alloc().initWithKey_ascending_("title", True)]
		return self

	def internalParameterKeys(self):
		return ["milestonesSortDescriptors", "upcomingActivitiesSortDescriptors", "overdueActivitiesSortDescriptors", "deadlineActivitiesSortDescriptors", "issuesSortDescriptors", "infoElementsSortDescriptors", "risksSortDescriptors", "resourcesSortDescriptors", "masterResourcesSortDescriptors", "filesSortDescriptors"]

		
	def masterResources(self):
		sortedMasterResources = self.project.sortedMasterResources()
		return sortedMasterResources
		

	def resources(self):
		predicate = NSPredicate.predicateWithFormat_argumentArray_("isPrivate = FALSE", None)
		resources = self.project.visibleResources().allObjects().filteredArrayUsingPredicate_(predicate)
		resources = resources.sortedArrayUsingDescriptors_(self.resourcesSortDescriptors)
		return resources
		
	def roles(self):
		roles = self.project.roles()
		roles = roles.sortedArrayUsingDescriptors_(self.resourcesSortDescriptors)
		return roles
		
	def expectedCostsByRole(self):
		result = 0
		resources = self.iterItem.valueForKey_("resources")
		if resources != None:
			for aRes in resources:
				aWorkCost = aRes.expectedWorkCost()
				result = result + aWorkCost	
		
		return result
		
	def resourcesByRole(self):
		resourcesList = []
		
		resources = self.iterItem.valueForKey_("resources")
		for aRes in resources:
			aTitle = aRes.title()
			#aValue = aTitle.expectedWorkCost()
			resourcesList.append(aTitle)
		return resourcesList

	def expectedCostsByRoleAndResource(self):
		resourcesList = []
		resources = self.iterItem.valueForKey_("resources")
		if resources != None:
			for aRes in resources:
				aWorkCost = aRes.expectedWorkCost()
				resourcesList.append(aWorkCost)			
		return resourcesList
	
	def showObjective(self):
		return self.withObjective and self.project.itemDescription()


	def rowClass(self):
		if self.iterIndex%2:
			return "even"

	def listItemClass(self):
		if self.iterIndex == 0:
			return "first"
	
	def dateFormat(self):
		if self.withTimes:
			return "medium/short"
		else:
			return "medium"

